=== debian/changelog ===
hugin (2016.0.0+dfsg-1build1) yakkety; urgency=medium

  * No-change rebuild against libvigraimpex6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 10 Jul 2016 07:09:25 +0000

hugin (2016.0.0+dfsg-1) unstable; urgency=medium

  * Bump version number, contents identical.
  * 45_typo_fixes.diff: Fix typos found by lintian.

 -- Andreas Metzler <ametzler@debian.org>  Thu, 05 May 2016 13:33:27 +0200

hugin (2016.0.0~rc2+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 19 Mar 2016 18:44:26 +0100

hugin (2016.0.0~rc2+dfsg-1) experimental; urgency=medium

  * New upstream version.
  * Build with DEB_BUILD_MAINT_OPTIONS := hardening=+all.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 12 Mar 2016 17:27:17 +0100

hugin (2016.0.0~rc1+dfsg-1) experimental; urgency=medium

  * New upstream version.
    + Drop 50_missingx11_dep.patch 51_0001-Typo-fixes.patch
      52_0002-correct-whatis-entry-in-generated-manpage.patch.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 28 Feb 2016 13:28:42 +0100

hugin (2016.0.0~beta1+dfsg-1) experimental; urgency=medium

  * Move Vcs-* from git/http to https.
  * New upstream version.
    + Drop patches/42_stoplinklibXI_libXmu.
    + Add b-d on liblcms2-dev.
    + Drop unused b-d on freeglut3-dev.
    + README_JP is gone, stop trying to install it.
    + 50_missingx11_dep.patch: Add -lX11 to linker line.
    + Requires cmake 2.8.12, bump b-d version
    + Needs boost >= 1.47, fix b-d version.
  * [lintian] 51_0001-Typo-fixes.patch
    52_0002-correct-whatis-entry-in-generated-manpage.patch
    Typo and formatting fixes, forwarded upstream.
  * [lintian] Drop hugin menu file, we already ship a desktop file for these
    commands.
  * Upload to experimental.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 24 Jan 2016 17:35:42 +0100
